;*** Krmiljenje ISD cipa z 9600bps RS-232 - S53MV - 07.07.2007 ***

;*** Uporaba vrat PICa 16F84 (takt 4MHz) ***
;nepovezani izhodi RA0-4
;RS-232 vhod INTF=RB0
;nepovezani izhodi RB1-3
;izhod ISD2560 M0=RA4
;vhod ISD2560 /OEM=RB5
;izhod ISD2560 PD=RB6
;izhod ISD2560 /CE=RB7

;*** Uporaba RAMa ***
;20,21	PREKIN resi W in STATUS
;22	PREKIN sprejeti bajt
;23	CAKAJ, OBDELA, STESPO stevec
;24	GOVOR, OBDELA, STESPO, INIPIC nov ukaz, ko je PD=RB6 postavljen
;25	GOVOR kuzapazi
;26	OBDELA, INIPIC casovnik
;27	OBDELA, INIPIC stara stevilka sporocila

;*** Zacetek programa, inicializacije ***
	LIST    P=16F84
	ORG	0
	CALL	INIPIC	;inicializacija vrat PICa
	GOTO	ZANKA

;*** Prekinitveni program *** (20,21,22)
	ORG	4
PREKIN	MOVWF   20      ;resi W
	SWAPF   3,0     ;resi STATUS
	MOVWF   21
	CLRF	22	;start
	CALL	CAKAJZ
	BTFSC	6,0	;bit 0 LSB
	BSF	22,0
	CALL	CAKAJB
	BTFSC	6,0	;bit 1
	BSF	22,1
	CALL	CAKAJB
	BTFSC	6,0	;bit 2
	BSF	22,2
	CALL	CAKAJB
	BTFSC	6,0	;bit 3
	BSF	22,3
	CALL	CAKAJB
	BTFSC	6,0	;bit 4
	BSF	22,4
	CALL	CAKAJB
	BTFSC	6,0	;bit 5
	BSF	22,5
	CALL	CAKAJB
	BTFSC	6,0	;bit 6
	BSF	22,6
	CALL	CAKAJB
	BTFSC	6,0	;bit 7
	BSF	22,7
	CALL	CAKAJB	;pocakaj se MSB in dva stop bita
	CALL	CAKAJB
	CALL	CAKAJB
	SWAPF	21,0	;obnovi STATUS
	MOVWF	3
	SWAPF	20,1	;obnovi W
	SWAPF	20,0
	BCF	0B,1	;resetiraj INTF
	RETFIE

;*** Cakaj poldrugi/en bit 9.6kbps (104us), 4MHz >>> 155/104 ukazov ***
CAKAJZ	MOVLW	24	;36 zank + call/return (4) + ostali ukazi (7)
	GOTO	CAKAJBZ
CAKAJB	MOVLW	18	;24 zank + call/return (4) + ostali ukazi (4)
	NOP
CAKAJBZ	ADDLW	0FF	;zanka 4 ukazi
	BTFSS	3,2
	GOTO	CAKAJBZ
	RETURN

;*** Inicializacija vrat PICa ***
INIPIC	MOVLW	0	;zacetno stanje vrat A=00000
	MOVWF	5
	MOVLW	0C0	;zacetno stanje vrat B=11000000
	MOVWF	6
	BSF	3,5	;postavi PAGE1
	BCF	1,6	;OPTION.6: INTEDG=0
	MOVLW	0	;TRISA: izhodi RA0-4
	MOVWF	5
	MOVLW	21	;TRISB: vhoda RB0,RB5, izhodi RB1-4,RB6-7
	MOVWF	6
	BCF	3,5	;postavi PAGE0
	CLRF	22
	MOVLW	1B	;preizkus GOVOR ob vklopu - predvaja 27.sporocilo
	MOVWF	24
	MOVWF	27
	CLRF	26
	CALL	CAKAJ	;cakanje 30ms
	BCF	0B,1	;resetiraj INTF
	BSF	0B,4	;vklopi INTE
	BSF	0B,7	;vklopi GIE
	RETURN

;*** Glavna zanka ***
ZANKA	CALL	CAKAJ	;cakanje 30ms
	CALL	GOVOR
	BTFSS	6,6	;ISD2560 PD postavljen?
	GOTO	ZANKA
	CALL	OBDELA	;obdela sprejeti bajt v stevilko sporocila
	GOTO	ZANKA

;*** Obdelaj sprejeti bajt, casovnik za enako *** (23,24,26,27)
OBDELA	MOVF	26,0	;odstevaj casovnik (26) do 0
	BTFSS	3,2
	DECF	26,1
	MOVF	22,0	;sprejeti bajt v (23) v obdelavo
	MOVWF	23
	BTFSC	23,7	;preveri bit7=0?
	RETURN
	MOVLW	40	;obrni bit6
	XORWF	23,1
	CALL	STESPO	;pretvori visino v stevilko sporocila v (24)
	MOVF	26,0	;preveri casovnik (26) iztekel do 0?
	BTFSC	3,2
	GOTO	OBDELA1
	MOVF	24,0	;brez sporocila casovnik nespremenjen?
	BTFSC	3,2
	RETURN
	SUBWF	27,0	;enako sporocilo pocakaj?
	BTFSS	3,2
	GOTO	OBDELA1
	CLRF	24	;pobrisi enako sporocilo, casovnik nespremenjen
	RETURN
OBDELA1	MOVF	24,0	;prepisi novo (24) v staro sporocilo (27)
	MOVWF	27
	MOVLW	0C8	;zacetna vrednost casovnika (26) 200=6sekund
	MOVWF	26
	RETURN

;*** Pretvori visino v stevilko sporocila *** (23,24)
STESPO	MOVF	23,0
	MOVWF	24
	INCF	24,1
	MOVLW	9	;9
	SUBWF	23,1
	BTFSS	3,0
	RETURN
	DECF	24,1
	MOVLW	2	;11
	SUBWF	23,1
	BTFSS	3,0
	RETURN
	DECF	24,1
	MOVLW	3	;14
	SUBWF	23,1
	BTFSS	3,0
	RETURN
	DECF	24,1
	MOVLW	2	;16
	SUBWF	23,1
	BTFSS	3,0
	RETURN
	DECF	24,1
	MOVLW	2	;18
	SUBWF	23,1
	BTFSS	3,0
	RETURN
	DECF	24,1
	MOVLW	2	;20
	SUBWF	23,1
	BTFSS	3,0
	RETURN
	DECF	24,1
	MOVLW	2	;22
	SUBWF	23,1
	BTFSS	3,0
	RETURN
	DECF	24,1
	MOVLW	2	;24
	SUBWF	23,1
	BTFSS	3,0
	RETURN
	DECF	24,1
	MOVLW	2	;26
	SUBWF	23,1
	BTFSS	3,0
	RETURN
	DECF	24,1
	MOVLW	2	;28
	SUBWF	23,1
	BTFSS	3,0
	RETURN
	DECF	24,1
	MOVLW	1	;29
	SUBWF	23,1
	BTFSS	3,0
	RETURN
	DECF	24,1
	MOVLW	2	;31
	SUBWF	23,1
	BTFSS	3,0
	RETURN
	DECF	24,1
	MOVLW	2	;33
	SUBWF	23,1
	BTFSS	3,0
	RETURN
	DECF	24,1
	MOVLW	2	;35
	SUBWF	23,1
	BTFSS	3,0
	RETURN
	DECF	24,1
	MOVLW	5	;40
	SUBWF	23,1
	BTFSS	3,0
	RETURN
	DECF	24,1
	MOVLW	1	;41
	SUBWF	23,1
	BTFSS	3,0
	RETURN
	CLRF	24
	RETURN

;*** Dvojna zanka cakanja 30ms *** (23)
CAKAJ	MOVLW   1E
	MOVWF   23
CAKAJ1	CALL    CAKAJ2
	DECFSZ  23,1
	GOTO    CAKAJ1
	RETURN
CAKAJ2  MOVLW   0C8	;notranja zanka 1ms @ 4MHz
CAKAJ3  NOP
	ADDLW   0FF
	BTFSS   3,2
	GOTO    CAKAJ3
	RETURN

;*** Krmiljenje govornega cipa ISD2560 *** (24,25)
GOVOR	BTFSS	6,6	;PD postavljen?
	GOTO	GOVOR1
	MOVF	24,0	;nov ukaz?
	BTFSC	3,2
	RETURN
	BCF	6,6	;zagon PD
	RETURN
GOVOR1	MOVF	24,0	;nicla - predvajanje!
	BTFSC	3,2	
	GOTO	GOVOR2
	BCF	6,4	;A0/M0=0 za predvajanje
	DECFSZ	24,1
	BSF	6,4	;A0/M0=1 za preskok
	NOP	;ISD impulz /CE z zakasnitvami
	NOP
	BCF	6,7
	NOP
	NOP
	BSF	6,7
	CLRF	25	;resetiraj kuzapazija (25)
	BCF	0B,0	;resetiraj RBIF v INTCON
	RETURN
GOVOR2	DECF	25,1	;cakanje kuzapazija (25)
	BTFSC	3,2
	BSF	6,6	;konec - izklop PD
	BTFSC	0B,0	;cakanje na konec RBIF
	BSF	6,6	;konec - izklop PD
	RETURN

;*** Nastavi konfiguracijo PICa 16F84 ***
	ORG	2007	;naslov konfiguracijske besede
	DW	1A	;CP=OFF, PWRTE=OFF, WDT=OFF, OSC=HS
	END

;*** Konec programa ***
